/*************  REVISION HISTORY  *********************



date: 2002/06/06 10:23:20;  
author: graham;    
Menusystem handles the args to console client.



date: 2002/06/05 01:12:17;  
author: graham;    
Copied menusystem files into final directory



date: 2002/06/04 21:37:57;  
author: nowell;  
Added directory for our final build





date: 2002/06/05 00:30:46;  
author: graham;    
Tweaked drawing methods.



date: 2002/06/03 00:55:13;  
author: graham;    
Changed the menusystem classes to use the real drawableobject.h instead of the one i created for testing. also changed <string.h> to <string> in image.h.



date: 2002/06/03 00:04:53;  
author: graham;    
Added math functions to menusystem files.



date: 2002/06/02 23:41:38;  
author: graham;    
Added "using namespace std" to everything



date: 2002/05/12 11:40:40;  
author: graham;    

I was comparing variables of different types (signed vs. unsigned int) so i chan
ged one of them so they'd match.



date: 2002/05/12 09:26:51;  
author: graham;    

Modified the graphics code. This should be the finished version.



date: 2002/05/10 01:41:13;  
author: graham;    

Added more graphics code.



date: 2002/05/09 12:06:48;  
author: graham;    

Added rudimentary graphics code.



date: 2002/05/08 07:38:20;  
author: graham;    

Made slight modifications to the widget classes to make MenuPane work.



date: 2002/05/07 02:28:28;  
author: graham;    

Added an isSelectable() function to all menuwidgets. It returns true if the widget is something that can be modified (eg, a slider) and false if it cannot be modified (eg, a label). MenuPane needs this information when it moves from one widget to the next.



date: 2002/03/21 02:23:01;  
author: graham;    




date: 2002/03/16 21:28:19;  
author: graham;    

Added a widgetID variable and accessor methods to each MenuWidget so that MenuPane could keep track of them.



date: 2002/03/14 20:38:00;  
author: graham;    

The ButtonWidget code here is completely tested, except that the graphics stuff isn't done yet. The Event classes are test event classes that construct inputevents out of alphanumeric keypresses for the purpose of testing the widgets.



date: 2002/02/22 01:41:43;  
author: graham;    

The code is identical to the previous revision, but has been run through a prettyprinter to clean it up.



date: 2002/02/20 22:31:14;  
author: graham;    

More methods added to the ButtonWidget class. Also, I'm no longer overriding DrawableObject's draw() methods.



date: 2002/02/20 11:23:23;  
author: graham;    

More slight modifications to these Widget classes..



date: 2002/02/19 00:39:36;  
author: graham;    

Slight modificataions to the code for the methods of ButtonWidget.



date: 2002/02/19 00:33:45;  
author: graham;  

Modifications to the RadioWidget class. Also, I missed the ButtonWidget.cc file earlier, so i'm adding it now.


***********  END REVISION HISTORY **********/

using namespace std;





/*******************************************************************************/
/* The includes for the superclasses are automatically listed.                 */
/* You need to specify any others                                              */
/*******************************************************************************/
#include "ButtonWidget.h"
#include "MenuWidget.h"
#include "drawableobject.h"
#include "enums.h"



/*******************************************************************************/
/* Events are handed to this function. Buttons accept only return/enter        */
/* events. Everything else is ignored.                                         */
/*******************************************************************************/
void ButtonWidget::receiveEvent( Event * e ) {
	if (e->getEventClass() == INPUT_EVENT && (EventTypeID)(e->getType()) == enterkey){
		toggleClick();
	}
}

/*******************************************************************************/
/* returns the value of the private variable clicked.                        */
/*******************************************************************************/
bool ButtonWidget::isClicked( void ) {
	return clicked;
}

/*******************************************************************************/
/* returns the text label on the button.                                       */
/*******************************************************************************/
string ButtonWidget::getText( void ) {
	return label;
}

void ButtonWidget::getText( unsigned char * c){
	for (unsigned int i = 0; i < 255 && i < label.length(); i++){
		c[i] = label[i];
	}
	if (label.length() < 256)
		c[255] = '\0';
	else
		c[label.length()] = '\0';
}


/*******************************************************************************/
/* Changes the label of the button to newLabel.                                */
/*******************************************************************************/
void ButtonWidget::setText( string newLabel ) {
	label = newLabel;
}

/*******************************************************************************/
/* Sets clicked to true.                                                     */
/*******************************************************************************/
void ButtonWidget::click( void ) {
	clicked = true;
}

/*******************************************************************************/
/* Sets the click-status of the button to the value of the boolean             */
/* argument.                                                                   */
/*******************************************************************************/
void ButtonWidget::setClick( bool theClick ) {
	clicked = theClick;
}

/*******************************************************************************/
/* Toggles the click-status of the button.                                     */
/*******************************************************************************/
void ButtonWidget::toggleClick( void ) {
	clicked = !clicked;
}

/*******************************************************************************/
/* Returns the widget identification number.                                   */
/*******************************************************************************/
int ButtonWidget::getWidgetID( void ) {
	return widgetID;
}

/*******************************************************************************/
/* Draws the widget normally (ie, not selected)                                */
/*******************************************************************************/
void ButtonWidget::draw ( void ) {
	
	// get the size of the window
    int win_width, win_height;
	win_width = glutGet(GLUT_WINDOW_WIDTH);
    win_height = glutGet(GLUT_WINDOW_HEIGHT);

	// save openGL's current settings
    glPushAttrib(GL_ENABLE_BIT | GL_TRANSFORM_BIT);
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_LIGHTING);

    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
	
	// set the window extants
	#ifdef k_UNSELECTED_ITEMS_SWIM
    glOrtho(0 + 5*sin(r1), win_width + 5 * sin(r2), 0 + 5* cos(r3), win_height+ 5*sin(r2+r3), 10,-10);
	#else
    glOrtho(0 , win_width , 0 , win_height, 10,-10);
	#endif

    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();

	#ifdef k_UNSELECTED_ITEMS_SWIM
	// if unselected items are supposed to swim around, increment
	// the angles we're using to calculate the modified position
	r1 += .005*((float)(rand() % 10));
	r2 += .005*((float)(rand() % 10));
	r3 += .005*((float)(rand() % 10));
	#endif
	
	// set the color for the rectangle depending on 
	// whether or not the button is clicked.
	if (isClicked())
		glColor3ub(50, 50, 152);
	else
		glColor3ub(152, 152, 50);

	// move the center to the center of the button
	glTranslatef(DrawableObject::getCenterX(), win_height - DrawableObject::getCenterY(), 0);

	// draw the button's rectangle
	glRectf(-DrawableObject::getWidth()/2, -DrawableObject::getHeight()/2 , DrawableObject::getWidth()/2, DrawableObject::getHeight()/2  );
	
	// set the color for the text and move slightly forward
	glColor3ub(255, 0, 0);
	glTranslatef(0, 0, .2);
	
	// calculate the length of the text string so we can
	// center it on the button
	int textwidth = Text::getStringWidth(label.data());
	
	// draw the text centered.
	#ifdef k_UNSELECTED_ITEMS_SWIM
	Text::print(label.data(), 
							(int)((DrawableObject::getCenterX()-textwidth/2)+10*sin(r1)), 
							(int)((win_height - DrawableObject::getCenterY()) + (9)+10*cos(r3)));
	#else
	Text::print(label.data(), 
							(int)((DrawableObject::getCenterX()-textwidth/2)), 
							(int)((win_height - DrawableObject::getCenterY()) - (9)));

	#endif
	
    glPopMatrix();	// restore openGL's previous settings

    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glPopAttrib();
}

/*******************************************************************************/
/* Draws the widget in "selected" mode.                                        */
/*******************************************************************************/
void ButtonWidget::drawSelected ( void ){
	
	// get the size of the window
    int win_width, win_height;
	win_width = glutGet(GLUT_WINDOW_WIDTH);
    win_height = glutGet(GLUT_WINDOW_HEIGHT);

	// save openGL's current settings
    glPushAttrib(GL_ENABLE_BIT | GL_TRANSFORM_BIT);
    glDisable(GL_DEPTH_TEST);
    glDisable(GL_LIGHTING);

    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
	
	// set the window extants
	#ifdef k_SELECTED_ITEMS_SWIM
    glOrtho(0 + 5*sin(r1), win_width + 5 * sin(r2), 0 + 5* cos(r3), win_height+ 5*sin(r2+r3), 10,-10);
	#else
    glOrtho(0 , win_width , 0 , win_height, 10,-10);
	#endif

    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
    glLoadIdentity();

	#ifdef k_SELECTED_ITEMS_SWIM
	// if selected items are supposed to swim around, increment
	// the angles we're using to calculate the modified position
	r1 += .005*((float)(rand() % 10));
	r2 += .005*((float)(rand() % 10));
	r3 += .005*((float)(rand() % 10));
	#endif
	
	// set the color for the rectangle depending on 
	// whether or not the button is clicked.
	if (isClicked())
		glColor3ub(0, 0, 252);
	else
		glColor3ub(252, 252, 0);

	// move the center to the center of the button
	glTranslatef(DrawableObject::getCenterX(), win_height - DrawableObject::getCenterY(), 0);

	// draw the button's rectangle
	glRectf(-DrawableObject::getWidth()/2, -DrawableObject::getHeight()/2 , DrawableObject::getWidth()/2, DrawableObject::getHeight()/2  );
	
	// set the color for the text and move slightly forward
	glColor3ub(255, 0, 0);
	glTranslatef(0, 0, .2);
	
	// calculate the length of the text string so we can
	// center it on the button
	int textwidth = Text::getStringWidth(label.data());
	
	// draw the text centered.
	#ifdef k_SELECTED_ITEMS_SWIM
	Text::print(label.data(), 
							(int)((DrawableObject::getCenterX()-textwidth/2)+10*sin(r1)), 
							(int)((win_height - DrawableObject::getCenterY()) - (9)+10*cos(r3)));
	#else
	Text::print(label.data(), 
							(DrawableObject::getCenterX()-textwidth/2), 
							(win_height - DrawableObject::getCenterY()) - (9));

	#endif
	
	// restore openGL's previous settings
    glPopMatrix();
    glMatrixMode(GL_PROJECTION);
    glPopMatrix();
    glPopAttrib();

}



/*******************************************************************************/
/* Constructor(s)                                                              */
/*******************************************************************************/

/*******************************************************************************/
/* Creates a button with the specified location and dimensions                 */
/* with the specified text as its label.                                       */
/*******************************************************************************/
ButtonWidget::ButtonWidget ( int width, int height, int centerX, int centerY, string text, int wid ): MenuWidget (width, height, centerX, centerY, wid) {
	setText(text);
	setClick(false);
	widgetID = wid;
	
	r1 = 0;
	r2 = 0;
	r3 = 0;
}



/*******************************************************************************/
/* Destructor                                                                  */
/*******************************************************************************/

ButtonWidget::~ButtonWidget ( void ) {
	
}

