/*************  REVISION HISTORY  *********************



date: 2002/06/05 01:12:17;  
author: graham;    
Copied menusystem files into final directory



date: 2002/06/04 21:37:57;  
author: nowell;  
Added directory for our final build





date: 2002/06/03 00:55:13;  
author: graham;    
Changed the menusystem classes to use the real drawableobject.h instead of the one i created for testing. also changed <string.h> to <string> in image.h.



date: 2002/06/03 00:12:14;  
author: graham;    

`



date: 2002/06/03 00:04:53;  
author: graham;    
Added math functions to menusystem files.



date: 2002/06/02 23:47:10;  
author: graham;    
Fixed capitalization on some #includes. My system doesn't care, but UGCS does.



date: 2002/06/02 23:41:38;  
author: graham;    
Added "using namespace std" to everything



date: 2002/05/09 12:06:48;  
author: graham;    

Added rudimentary graphics code.



date: 2002/05/08 07:38:20;  
author: graham;    

Made slight modifications to the widget classes to make MenuPane work.



date: 2002/03/21 02:23:01;  
author: graham;    




date: 2002/03/16 21:28:19;  
author: graham;    

Added a widgetID variable and accessor methods to each MenuWidget so that MenuPane could keep track of them.



date: 2002/03/14 20:38:00;  
author: graham;    

The ButtonWidget code here is completely tested, except that the graphics stuff isn't done yet. The Event classes are test event classes that construct inputevents out of alphanumeric keypresses for the purpose of testing the widgets.



date: 2002/02/22 20:59:22;  
author: graham;    

Added an image ID for the button when it is both selected AND clicked.



date: 2002/02/20 22:31:14;  
author: graham;    

More methods added to the ButtonWidget class. Also, I'm no longer overriding DrawableObject's draw() methods.



date: 2002/02/18 21:25:46;  
author: graham;    

I left out a #include in the last commit..



date: 2002/02/18 21:22:22;  
author: graham;  

These are updated header files for the menusystem, as generated by the online documentation.


***********  END REVISION HISTORY **********/


using namespace std;








#ifndef _BUTTONWIDGET_H_
#define _BUTTONWIDGET_H_


// The includes for the superclasses are automatically listed.
// You need to specify any others
#include "MenuWidget.h"
//#include "allmenu.h"
#include <string>
#include "drawableobject.h"
#include <math.h>


// Description:
//
// This widget is simply a button, such as an OK or Cancel button. 
// 

class ButtonWidget : public MenuWidget{
		// Data Members

	private:
		// isClicked is initialized to false. When the button 
		// is 'clicked' by pressing enter/return when the button is selected 
		// in the pane, isClicked is set to true.
 
		bool clicked;

		// The label for the button. 
		string label;

		// The id for the image of this button when it is neither selected 
		// nor clicked. 
		int normal_image_ID;

		// The id for the image of this button when it is selected. 
		int selected_image_ID;

		// The id for the image of this button when it is clicked. 
		int clicked_image_ID;

		// The id of the image for when it is both selected and clicked. 
		// 
		int selected_clicked_image_id;
		
		// the widget identification number
		int widgetID;

		// these are angles used in the draw() functions for positioning
		float r1;
		float r2;
		float r3;


	public:


		// Methods

	private:


	public:
		// Draws the widget in "selected" mode and "regular" mode, repectively
		void drawSelected( void );
		void draw( void );
		
		
		// Events are handed to this function. Buttons accept only return/enter 
		// events. Everything else is ignored. 
		void receiveEvent( Event * );

		// returns the value of the private variable isClicked. 
		bool isClicked( void );

		// Changes the label of the button to newLabel. 
		void setText( string );

		// Sets isClicked to true. 
		void click( void );

		// returns the label on the button. 
		string getText( void );
		void getText( unsigned char * );

		// Sets the click-status of the button to the value of the boolean 
		// argument. 
		void setClick( bool );

		// Toggles the click-status of the button. 
		void toggleClick( void );
		
		// returns the widget identification number
		int getWidgetID ( void );
		
		// returns true because the user can select this kind of menuwidget
		bool isSelectable (void) { return true; }



		// Constructor(s)

		// Creates a button with the specified location and dimensions 
		// with the specified text as its label. The last argument is the
		// widget identification number
		ButtonWidget ( int, int, int, int, string, int );



		// Destructor

		~ButtonWidget ( void );

};

#endif
