/*************  REVISION HISTORY  *********************



date: 2002/06/04 21:37:57;  
author: nowell;  
Added directory for our final build





date: 2002/06/03 00:04:53;  
author: graham;    
Added math functions to menusystem files.



date: 2002/06/02 23:41:38;  
author: graham;    
Added "using namespace std" to everything



date: 2002/05/12 09:33:27;  
author: graham;    

Fixed a typo.



date: 2002/05/12 06:08:51;  
author: graham;    

Added methods to my testing version of drawableobject.h.



date: 2002/05/10 10:12:18;  
author: graham;    

Modifications to tweak graphics code.



date: 2002/05/09 12:08:10;  
author: graham;    

Added #include <GL/glut.h> so that the class could call openGL routines.



date: 2002/05/08 07:44:57;  
author: graham;  

This is a stripped down DrawableObject class. I just created it to test my widgets with.


***********  END REVISION HISTORY **********/


using namespace std;





/******************************************************************************/
/* This isn't the actual drawable object class. This file only exists so that */
/* the widget test programs will compile.                                     */
/******************************************************************************/


#ifndef _DRAWABLE_OBJECT_H_
#define _DRAWABLE_OBJECT_H_

#include <math.h>

#ifdef __APPLE__
	#include <GLUT/glut.h>
#endif

#ifndef __APPLE__
	#include <GL/glut.h>
#endif


class DrawableObject{
		// Data Members

	private:
		// the x-value of the center of the object. 
		int centerX;

		// the y-value of the center of the object. 
		int centerY;

		// The width of the object in pixels. 
		int width;

		// The height of the object. 
		int height;

		// The key for the image for this item in the graphics hash. 
		// 
		int graphicsHashID;

	public:


		// Methods

	private:


	public:
	
//		virtual void draw( void ){
//			// do nothing
//		}
	
		// Returns the value of centerX. 
		int getCenterX( void ){
			return centerX;
		}

		// Returns the value of centerY. 
		int getCenterY( void ){
			return centerY;
		}
		
		// some of the widgets needed the drawableobject.getWidth() method
		int getWidth ( void ){
			return width;
		}

		// Returns the value of height. 
		int getHeight( void ){
			return height;
		}

		// Sets the width to the value of w.  Used when a parent draws this item
		void setWidth( unsigned int w ) 
		{
			width = w;
		}
		
		// Sets the height to the value of h.  Used when a parent draws this item
		void setHeight( unsigned int h ) 
		{
			height = h;
		}
		
		// Sets centerX to x.  Used when a parent draws this item
		void setCenterX( unsigned int x ) 
		{
			centerX = x;
		}
		
		// Sets centerY to y.  Used when a parent draws this item
		void setCenterY( unsigned int y ) 
		{
			centerY = y;
		}
		
		//set the id to the OpenGL texture key
		void setGraphicsHashID( int id) 
		{
			graphicsHashID = id;
		}
		
		
		// Returns the value of graphicsHashID, the key to this object's 
		// current image in the graphics hashtable. 
		int getGraphicsHashID( void ) 
		{
			return graphicsHashID;
		}
		// Constructor(s)

		// Creates a MenuWidget with the specified dimensions and location. 
		// 
		DrawableObject ( int the_id, int w, int h, int cx, int cy ){
			setGraphicsHashID(the_id);
			setWidth(w);
			setHeight(h);
			setCenterX(cx);
			setCenterY(cy);
		}
		
		virtual ~DrawableObject ( void ) {
			//do nothing
		}
};

#endif
